"2020-066 D-Fog"
"this is just a test for darck channel piorer on real time video"


import numpy as np
from PIL import Image

from guidedfilter import guided_filter

R, G, B = 0, 1, 2  # index for convenience
L = 256  # color depth


def get_dark_channel(I, w):
    """Get the dark channel prior in the (RGB) video .
    """
    M, N, _ = I.shape
    padded = np.pad(I, ((w / 2, w / 2), (w / 2, w / 2), (0, 0)), 'edge')
    darkch = np.zeros((M, N))
    for i, j in np.ndindex(darkch.shape):
        darkch[i, j] = np.min(padded[i:i + w, j:j + w, :])  
    return darkch


def get_atmosphere(I, darkch, p):
    """Get the atmosphere light in the (RGB) video.
    """
    
    M, N = darkch.shape
    flatI = I.reshape(M * N, 3)
    flatdark = darkch.ravel()
    searchidx = (-flatdark).argsort()[:M * N * p]  
   

    # return the highest intensity for each channel
    return np.max(flatI.take(searchidx, axis=0), axis=0)


def get_transmission(I, A, darkch, omega, w):
    """Get the transmission esitmate in the (RGB) video.
    """
    return 1 - omega * get_dark_channel(I / A, w)  


def dehaze_raw(I, tmin=0.2, Amax=220, w=15, p=0.0001,
               omega=0.95, guided=True, r=40, eps=1e-3):
    """Get the dark channel prior, atmosphere light, transmission rate
       and refined transmission rate for raw RGB video
    """
    m, n, _ = I.shape
    Idark = get_dark_channel(I, w)

    A = get_atmosphere(I, Idark, p)
    A = np.minimum(A, Amax)  # threshold A
    

    rawt = get_transmission(I, A, Idark, omega, w)
  
    rawt = refinedt = np.maximum(rawt, tmin)  # threshold t
    if guided:
        normI = (I - I.min()) / (I.max() - I.min())  # normalize I
        refinedt = guided_filter(normI, refinedt, r, eps)

    
    return Idark, A, rawt, refinedt


def get_radiance(I, A, t):
    """Recover the radiance from raw video data with atmosphere light
       and transmission rate estimate.
    """
    tiledt = np.zeros_like(I)  
    tiledt[:, :, R] = tiledt[:, :, G] = tiledt[:, :, B] = t
    return (I - A) / tiledt + A  


def dehaze(im, tmin=0.2, Amax=220, w=15, p=0.0001,
           omega=0.95, guided=True, r=40, eps=1e-3):
  
    I = np.asarray(im, dtype=np.float64)
    Idark, A, rawt, refinedt = dehaze_raw(I, tmin, Amax, w, p,
                                          omega, guided, r, eps)
    white = np.full_like(Idark, L - 1)

    def to_img(raw):
       
        cut = np.maximum(np.minimum(raw, L - 1), 0).astype(np.uint8)

       

    return [to_img(raw) for raw in (Idark, white * rawt, white * refinedt,
                                    get_radiance(I, A, rawt),
                                    get_radiance(I, A, refinedt))]
